# CSSType

TypeScript definitions for CSS, generated by [data from MDN](https://github.com/mdn/data). It provides autocompletion and type checking for CSS properties and values.

```ts
const style: CSS.Properties = {
  flexDirection: 'columns', // -> Type '"rows"' is not assignable to type 'FlexDirection'.
  opacity: '10%', // -> Type 'string' is not assignable to type 'number'.
  bakground: 'red', // -> Object literal may only specify known properties, and 'bakground' does not exist in type 'Properties'.
}
```

## Getting started

```bash
$ npm install csstype@latest # For projects
$ npm install csstype@* # For libraries
```
